VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Flash Cards -> Windows Substitute"
   ClientHeight    =   4455
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4095
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   4095
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDisplay 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2895
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   0
      Width           =   4095
   End
   Begin VB.CommandButton cmdFile 
      Caption         =   "Load Cards"
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   3720
      Width           =   1215
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit FCWS"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   3720
      Width           =   1215
   End
   Begin VB.TextBox txtCard 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   0
      Locked          =   -1  'True
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   2880
      Width           =   4095
   End
   Begin VB.CommandButton cmdSeek 
      Caption         =   "Seek to Card #"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1320
      TabIndex        =   3
      Top             =   3720
      Width           =   1455
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Go Forwards ----->"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2400
      TabIndex        =   1
      Top             =   3240
      Width           =   1695
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "<----- Go Backwards"
      Enabled         =   0   'False
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   3240
      Width           =   1695
   End
   Begin MSComDlg.CommonDialog cdlDialogs 
      Left            =   1800
      Top             =   3240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Open FCTS file (*.89y)"
      Filter          =   "Misc. TI-89 Files (*.89y)|*.89y|All Files (*.*)|*.*"
      Flags           =   4100
   End
   Begin VB.Label lblAbout 
      Alignment       =   2  'Center
      Caption         =   "FCWS v0.0.1 by Austin Chu (qarv@yahoo.com)"
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   4200
      Width           =   4095
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*--------------------------------------------------------------------------------------*/
'* Flash Cards -> Windows Substitute (FCWS)                                             */
'* Programmer: Austin Chu (qarv@yahoo.com)                                              */
'* Programmed in Visual Basic for Microsoft Visual Basic 6                              */
'* Version: 0.0.1 (first working version, i.e. alpha-1)                                 */
'*                                                                                      */
'* frmMain - The only form                                                              */
'*--------------------------------------------------------------------------------------*/

' All of the code algorithms have been adapted to Visual Basic from the TI-GCC program
' Flash Cards -> TI Substitute v0.0.1 from Electronic Flash Cards Package, also by Austin
' Chu.  The required input file format is the type outputed by Text -> FCTS Converter
' v0.0.1, also in EFCP.

Option Explicit
Private filenum As Integer                  ' The file number
Private numCards As Integer                 ' The total number of cards
Private curIndex As Integer                 ' Marker for the current card (+front, -back)
Private curPos As Long                      ' A file position saver

' Resets the display
Private Sub ResetDisplay()
    Dim nextChar As String                  ' The next character
    nextChar = " "
    Dim nextByte As Byte                    ' The next byte
    Dim filePos As Long                     ' The position of the next character
    filePos = curPos
    
    txtDisplay.Text = ""
    txtCard.Text = ""
    
    ' Update the card number display
    If curIndex > 0 Then
        txtCard.Text = "Front, " & curIndex & " of " & numCards
    Else
        txtCard.Text = "Back, " & -curIndex & " of " & numCards
    End If
    
    ' Loop through the card contents
    Get #filenum, filePos, nextByte
    Do While nextByte <> 0
        Get #filenum, filePos, nextChar
        txtDisplay.Text = txtDisplay.Text & nextChar
        filePos = filePos + 1
        Get #filenum, filePos, nextByte
    Loop
End Sub

' A replacement for while(*curPos++) { } or while(*curPos--) { }
' increment=1 to seek forward, increment=-1 to seek backwards
Private Sub SeekLoop(increment As Integer)
    Dim temp As Byte                        ' Temporary place for file data
    Do                                      ' The loop
        Get #filenum, curPos, temp
        curPos = curPos + increment
    Loop Until temp = 0
End Sub

' Return to the previous part
Private Sub cmdBack_Click()
    If curIndex = 1 Then
        ' Loop back to back of last card
        curIndex = -numCards
        ' Get the curPos
        curPos = LOF(filenum) - 10
        SeekLoop -1
        curPos = curPos + 2
    Else
        curPos = curPos - 2                 ' Get into the previous string
        SeekLoop -1                         ' Loop until 2 strings before is hit
        curPos = curPos + 2                 ' Push forward into wanted string
        ' Set curIndex
        If curIndex > 0 Then
            curIndex = -(curIndex - 1)
        Else
            curIndex = -curIndex
        End If
    End If
    ResetDisplay
End Sub

' Exit FCWS
Private Sub cmdExit_Click()
    Unload frmMain
End Sub

' Change the card set
Private Sub cmdFile_Click()
    On Error Resume Next
    Dim newfile As Integer                  ' The file number of the new file
    Dim data As String                      ' A temporary holder for tests
    Dim bytedata As Byte                    ' A temporary holder for the byte data
    
    ' Get a file name
    cdlDialogs.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    End If
    
    ' Open the file
    newfile = FreeFile
    Open cdlDialogs.FileName For Binary Access Read Lock Read As #newfile
    
    ' Check the **TI89**
    data = String(8, " ")
    Get #newfile, 1, data
    If data <> "**TI89**" Then
        Close #newfile
        MsgBox "The selected file is not a valid FCTS file.", vbOKOnly, "Invalid File"
        Exit Sub
    End If
    
    ' Check for the fcts extension
    data = String(4, " ")
    Get #newfile, LOF(newfile) - 7, data
    If data <> "fcts" Then
        Close #newfile
        MsgBox "The selected file is not a valid FCTS file.", vbOKOnly, "Invalid File"
        Exit Sub
    End If
    
    ' Check version number
    Get #newfile, &H59, bytedata
    If bytedata <> 0 Then
        Close #newfile
        MsgBox "This version of FCWS does not support the version of the selected file", _
            vbOKOnly, "Invalid File"
        Exit Sub
    End If
    Get #newfile, &H5A, bytedata
    If bytedata <> 1 Then
        Close #newfile
        MsgBox "This version of FCWS does not support the version of the selected file", _
            vbOKOnly, "Invalid File"
        Exit Sub
    End If
    
    ' Update button caption and enable browsing buttons OR close old file
    If cmdFile.Caption = "Load Cards" Then
        cmdFile.Caption = "Change Cards"
        cmdBack.Enabled = True
        cmdNext.Enabled = True
        cmdSeek.Enabled = True
    Else
        Close #filenum
    End If
    
    ' Reset the display
    filenum = newfile
    Get #filenum, &H5B, bytedata
    numCards = bytedata * &H100
    Get #filenum, &H5C, bytedata
    numCards = numCards + bytedata
    curIndex = 1
    curPos = &H5E
    ResetDisplay
End Sub

' Continue to next part
Private Sub cmdNext_Click()

    Dim temp As Byte                        ' A temporary place for file data
    SeekLoop 1                              ' Loop until next string
    Get #filenum, curPos, temp
    If temp = 0 Then                        ' End of file hit; return to first card
        curIndex = 1
        curPos = &H5E
    Else
        ' Set curIndex
        If curIndex > 0 Then
            curIndex = -curIndex
        Else
            curIndex = -curIndex + 1
        End If
    End If
    ResetDisplay
End Sub

' Goto a certain card
Private Sub cmdSeek_Click()
    On Error Resume Next
    Dim index As Integer                    ' The new index and a loop index
    
    ' Get the new index
    index = CInt(InputBox("Number of the card:", "Goto a Card"))
    
    ' Test the new index
    If index <= 0 Or index > numCards Then
        MsgBox "The specified card number is invalid", vbOKOnly, "Invalid Card Number"
        Exit Sub
    End If
    
    ' Set up the globals curIndex and curPos
    curIndex = index
    If curIndex > numCards / 2 Then         ' The card is more than halfway through
        ' Start seeking from the bottom of the stack
        curPos = LOF(filenum) - 10
        For index = numCards To curIndex Step -1
            SeekLoop -1
            SeekLoop -1
        Next index
        curPos = curPos + 2                 ' Push forward to the wanted string
    Else
        ' Start seeking from the top of the stack
        curPos = &H5E
        For index = 1 To curIndex - 1 Step 1
            SeekLoop 1
            SeekLoop 1
        Next index
    End If
    
    ResetDisplay
End Sub

' End the program
Private Sub Form_Unload(Cancel As Integer)
    If cmdFile.Caption = "Change Cards" Then
        Close #filenum
    End If
End Sub

Private Sub txtDisplay_Change()

End Sub
